#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleCommand = exports.parsedArg = exports.deleteKey = exports.renameKey = exports.backupKey = exports.newKey = exports.switchKey = exports.getList = exports.getCurrent = exports.getDirectories = exports.bufferToString = exports.SWITCH_FILE = exports.SSH_PATH = exports.HOME_PATH = void 0;
// import necessary files
var fs_1 = require("fs");
var os = __importStar(require("os"));
var rmdir = __importStar(require("rimraf"));
var forge = __importStar(require("node-forge"));
var keypair_1 = __importDefault(require("keypair"));
var yargs_1 = __importDefault(require("yargs"));
var helpers_1 = require("yargs/helpers");
// Get path for work
exports.HOME_PATH = "".concat(os.homedir(), "/");
exports.SSH_PATH = "".concat(exports.HOME_PATH, ".ssh/");
exports.SWITCH_FILE = "".concat(exports.SSH_PATH, ".sshwitch");
// get buffer to string
var bufferToString = function (buffer) {
    if (buffer === void 0) { buffer = ''; }
    return buffer.toString();
};
exports.bufferToString = bufferToString;
// Get the all directory aka keys
var getDirectories = function (source) {
    var _a, _b;
    return (_b = (_a = (0, fs_1.readdirSync)(source, {
        withFileTypes: true,
    })) === null || _a === void 0 ? void 0 : _a.filter(function (dirent) { return dirent.isDirectory(); })) === null || _b === void 0 ? void 0 : _b.map(function (dirent) { return dirent.name; });
};
exports.getDirectories = getDirectories;
// Get current key
var getCurrent = function () {
    try {
        return (0, fs_1.readFileSync)(exports.SWITCH_FILE).toString();
    }
    catch (e) {
        (0, fs_1.writeFileSync)(exports.SWITCH_FILE, '');
        return (0, exports.bufferToString)((0, fs_1.readFileSync)(exports.SWITCH_FILE));
    }
};
exports.getCurrent = getCurrent;
// get all ssh keys
var getList = function () {
    var _a;
    (_a = (0, exports.getDirectories)(exports.SSH_PATH)) === null || _a === void 0 ? void 0 : _a.map(function (item) { return console.log(item); });
    return (0, exports.getDirectories)(exports.SSH_PATH);
};
exports.getList = getList;
// Switch ssh key
var switchKey = function (keyName) {
    try {
        if ((0, fs_1.existsSync)("".concat(exports.SSH_PATH + keyName, "/id_rsa")) &&
            (0, fs_1.existsSync)("".concat(exports.SSH_PATH + keyName, "/id_rsa.pub"))) {
            try {
                (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH + keyName, "/id_rsa"), "".concat(exports.SSH_PATH, "id_rsa"));
                (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH + keyName, "/id_rsa.pub"), "".concat(exports.SSH_PATH, "id_rsa.pub"));
                (0, fs_1.writeFileSync)(exports.SWITCH_FILE, keyName);
                (0, fs_1.chmodSync)("".concat(exports.SSH_PATH, "/id_rsa.pub"), 384);
                (0, fs_1.chmodSync)("".concat(exports.SSH_PATH, "/id_rsa"), 384);
                return console.log("Changed key pair to: ".concat(keyName));
            }
            catch (err) {
                console.log("Could not copy, check if you have permission to write on ".concat(exports.SSH_PATH));
                return console.error(err);
            }
        }
        else {
            console.log("Could not read key pair in ".concat(exports.SSH_PATH + keyName));
            console.log("Check if key pair exists in ".concat(exports.SSH_PATH + keyName, "\n\n"));
            console.log("If not you can create a new one with: \"sshmulti -n ".concat(keyName, "\""));
            return console.log("Or backup the current key pair in ".concat(exports.SSH_PATH, " with: \"sshmulti -b ").concat(keyName, "\""));
        }
    }
    catch (err) {
        return console.error(err);
    }
};
exports.switchKey = switchKey;
// Register new ssh key
var newKey = function (newName) {
    if ((0, fs_1.existsSync)(exports.SSH_PATH + newName)) {
        return console.log("".concat(exports.SSH_PATH + newName, " already exists, skipping"));
    }
    console.log("Creating key pair in ".concat(exports.SSH_PATH + newName));
    try {
        (0, fs_1.mkdirSync)(exports.SSH_PATH + newName);
        var pair = (0, keypair_1.default)();
        var publicKey = forge.pki.publicKeyFromPem(pair.public);
        var privateKey = forge.pki.privateKeyFromPem(pair.private);
        var ssh = forge.ssh.publicKeyToOpenSSH(publicKey);
        var sshPrivate = forge.ssh.privateKeyToOpenSSH(privateKey);
        (0, fs_1.writeFileSync)("".concat(exports.SSH_PATH + newName, "/id_rsa.pub"), ssh);
        (0, fs_1.writeFileSync)("".concat(exports.SSH_PATH + newName, "/id_rsa"), sshPrivate);
        (0, fs_1.chmodSync)("".concat(exports.SSH_PATH + newName, "/id_rsa.pub"), 384);
        (0, fs_1.chmodSync)("".concat(exports.SSH_PATH + newName, "/id_rsa"), 384);
        (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH + newName, "/id_rsa"), "".concat(exports.SSH_PATH, "id_rsa"));
        (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH + newName, "/id_rsa.pub"), "".concat(exports.SSH_PATH, "id_rsa.pub"));
        (0, fs_1.writeFileSync)(exports.SWITCH_FILE, newName);
        return console.log("\n public key: \n\n ".concat(ssh, "\n private key: \n\n ").concat(sshPrivate));
    }
    catch (err) {
        console.log("Could not create key pair, check if you have permission to write on ".concat(exports.SSH_PATH + newName));
        return console.log(err);
    }
};
exports.newKey = newKey;
// backup ssh keys
var backupKey = function (oldName) {
    if ((0, fs_1.existsSync)(exports.SSH_PATH + oldName)) {
        return console.log("".concat(exports.SSH_PATH + oldName, " already exists, skipping"));
    }
    console.log("Copying current key pair in ".concat(exports.SSH_PATH, " to ").concat(exports.SSH_PATH + oldName));
    try {
        (0, fs_1.mkdirSync)(exports.SSH_PATH + oldName);
        (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH, "id_rsa"), "".concat(exports.SSH_PATH + oldName, "/id_rsa"));
        (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH, "id_rsa.pub"), "".concat(exports.SSH_PATH + oldName, "/id_rsa.pub"));
        return console.log("Backup to current key pair in ".concat(exports.SSH_PATH, " to ").concat(exports.SSH_PATH + oldName));
    }
    catch (err) {
        console.log("Could not backup key pair, check if you have permission to write on ".concat(exports.SSH_PATH + oldName));
        return console.log(err);
    }
};
exports.backupKey = backupKey;
// Rename ssh key
var renameKey = function (oldName, newName) {
    if (!(0, fs_1.existsSync)(exports.SSH_PATH + oldName)) {
        return console.log("".concat(exports.SSH_PATH + oldName, " doesn't exists, cannot rename"));
    }
    if ((0, fs_1.existsSync)(exports.SSH_PATH + newName)) {
        return console.log("".concat(exports.SSH_PATH + newName, " already exists, cannot rename"));
    }
    try {
        (0, fs_1.renameSync)(exports.SSH_PATH + oldName, exports.SSH_PATH + newName);
        if ((0, exports.getCurrent)() === oldName) {
            (0, fs_1.writeFileSync)(exports.SWITCH_FILE, newName);
            (0, exports.switchKey)(newName);
        }
        return console.log("Renamed ".concat(oldName, " key to ").concat(newName));
    }
    catch (err) {
        console.log('Could not rename key pair');
        return console.log(err);
    }
};
exports.renameKey = renameKey;
// delete ssh key
var deleteKey = function (deletedName) {
    if (!(0, fs_1.existsSync)(exports.SSH_PATH + deletedName)) {
        return console.log("".concat(exports.SSH_PATH + deletedName, " doesn't exists, cannot delete"));
    }
    try {
        rmdir.sync(exports.SSH_PATH + deletedName);
        return console.log("Deleted ".concat(deletedName, " sshkey."));
    }
    catch (e) {
        return console.log(e);
    }
};
exports.deleteKey = deleteKey;
// Using argv for taking flag and input
exports.parsedArg = (0, yargs_1.default)((0, helpers_1.hideBin)(process.argv))
    .usage("\n    Switch and manage key pairs in ".concat(exports.SSH_PATH, "\n    Default usage: sshmulti key_pair_name\n    Advanced usage: sshmulti [option]\n    -c, --current                    Get name of current key pair\n    -n, --new                        New key pair name\n    -b, --backup                     Backup key pair in ").concat(exports.SSH_PATH, "\n    -r, --rename                     Rename a key pair\n    -l, --list                       Get list of key pairs in ").concat(exports.SSH_PATH, "\n    -d, --delete DELETE              Delete key pair\n    "))
    .help('help')
    .alias('help', 'h')
    .version('version', process.env.npm_package_version || '3.0.2')
    .alias('version', 'V')
    .options({
    backup: { type: 'boolean', alias: ['backup', 'b'], default: false },
    new: { type: 'boolean', alias: ['new', 'n'], default: false },
    rename: { type: 'boolean', alias: ['rename', 'r'], default: false },
    list: { type: 'boolean', alias: ['list', 'l'], default: false },
    current: { type: 'boolean', alias: ['current', 'c'], default: false },
    delete: { type: 'boolean', alias: ['delete', 'd'], default: false },
}).argv;
var handleCommand = function (argv) {
    var isBackup = argv.backup, isCurrent = argv.current, isDelete = argv.delete, isList = argv.list, isRename = argv.rename, isNew = argv.new, name = argv._;
    if (isBackup && name[0].toString().length >= 1) {
        return (0, exports.backupKey)(name[0].toString());
    }
    if (isRename && name.length === 2) {
        return (0, exports.renameKey)(name[0].toString(), name[1].toString());
    }
    if (isNew && name.length === 1) {
        return (0, exports.newKey)(name[0].toString());
    }
    if (isDelete && name.length === 1) {
        return (0, exports.deleteKey)(name[0].toString());
    }
    if (isList) {
        return (0, exports.getList)();
    }
    if (isCurrent || name.length === 0) {
        return console.log((0, exports.getCurrent)());
    }
    if (!isBackup &&
        !isCurrent &&
        !isDelete &&
        !isList &&
        !isRename &&
        !isNew &&
        name.length === 1) {
        return (0, exports.switchKey)(name[0].toString());
    }
    return console.log('Please enter valid name. Type sshmulti --help for more.');
};
exports.handleCommand = handleCommand;
(function () { return __awaiter(void 0, void 0, void 0, function () {
    var argv;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.parsedArg];
            case 1:
                argv = _a.sent();
                (0, exports.handleCommand)(argv);
                return [2 /*return*/];
        }
    });
}); })();
exports.default = exports.getDirectories;
