#!/usr/bin/env node
/// <reference types="node" />
import { PathLike } from 'fs';
export declare const HOME_PATH: string;
export declare const SSH_PATH: string;
export declare const SWITCH_FILE: string;
export declare const bufferToString: (buffer?: string | Buffer | undefined) => string;
export declare const getDirectories: (source: PathLike) => string[];
export declare const getCurrent: () => string;
export declare const getList: () => string[];
export declare const switchKey: (keyName: string | NodeJS.ArrayBufferView) => void;
export declare const newKey: (newName: string) => void;
export declare const backupKey: (oldName: string) => void;
export declare const renameKey: (oldName: string, newName: string) => void;
export declare const deleteKey: (deletedName: string) => void;
export declare const parsedArg: {
    [x: string]: unknown;
    backup: boolean;
    new: boolean;
    rename: boolean;
    list: boolean;
    current: boolean;
    delete: boolean;
    _: (string | number)[];
    $0: string;
} | Promise<{
    [x: string]: unknown;
    backup: boolean;
    new: boolean;
    rename: boolean;
    list: boolean;
    current: boolean;
    delete: boolean;
    _: (string | number)[];
    $0: string;
}>;
export declare const handleCommand: (argv: {
    [x: string]: unknown;
    backup: boolean;
    new: boolean;
    rename: boolean;
    list: boolean;
    current: boolean;
    delete: boolean;
    _: (string | number)[];
    $0: string;
}) => void | string[];
export default getDirectories;
